#ifndef EXECLINE_H
#define EXECLINE_H

#include "gccattributes.h"
#include "stralloc.h"
#include "envalloc.h"


/* Debug */

extern void env_print (char *const *const, unsigned int) ;


/* Basics */

extern int el_argv_cat (stralloc *, char const *const *) gccattr_deprecated ;
extern char const **el_argv_make (int, char const *, unsigned int) gccattr_deprecated ;

extern int el_vardupl (char const *, char const *, unsigned int) gccattr_pure ;


/* Environment shifting */

extern int el_pushenv (stralloc *, char const *const *, unsigned int, char const *const *, unsigned int) ;
extern int el_popenv  (stralloc *, char const *const *, unsigned int, char const *const *, unsigned int) ;


/* Sequence */

extern void el_execsequence (char const *const *, char const *const *) gccattr_noreturn ;


/* Block unquoting */

extern int el_semicolon (char const **) ;


/* Value splitting */

typedef struct elsplitinfo elsplitinfo, *elsplitinfo_ref ;
struct elsplitinfo
{
  unsigned char split : 1 ;
  unsigned char nocrunch : 1 ;
  char const *delim ;
} ;

#define ELSPLITINFO_ZERO { 0, 0, " \n\r\t" }

extern unsigned int el_splitc (stralloc *, unsigned int, char const *) ;
extern unsigned int el_splitnc (stralloc *, unsigned int, char const *) ;
extern int el_splitnetstring (stralloc *, unsigned int) ;
extern int el_split (stralloc *, unsigned int, elsplitinfo const *) ;
extern int el_split0 (stralloc *, unsigned int, elsplitinfo const *) ;


/* Substitution */

typedef struct elsubst elsubst, *elsubst_ref ;
struct elsubst
{
  char const *var ;
  char const *value ;
  unsigned int n ;
} ;

extern void el_updatesubsts (elsubst *, unsigned int, char const *, char const *, unsigned int *) ;
extern int el_substitute (stralloc *, char const *, unsigned int, elsubst const *, unsigned int) ;

#endif
